--[[
    ----------------------------------------------------------------------------
    App für den Unilog von SM-Modelltechnik auf der Jeti DC-16
    ----------------------------------------------------------------------------
	MIT License
	
    Copyright (c) 2017 A. Fromm
   
    Hiermit wird unentgeltlich jeder Person, die eine Kopie der Software und der
    zugehörigen Dokumentationen (die "Software") erhält, die Erlaubnis erteilt,
    sie uneingeschränkt zu nutzen, inklusive und ohne Ausnahme mit dem Recht, sie
    zu verwenden, zu kopieren, zu verändern, zusammenzufügen, zu veröffentlichen,
    zu verbreiten, zu unterlizenzieren und/oder zu verkaufen, und Personen, denen
    diese Software überlassen wird, diese Rechte zu verschaffen, unter den
    folgenden Bedingungen: 
    Der obige Urheberrechtsvermerk und dieser Erlaubnisvermerk sind in allen Kopien
    oder Teilkopien der Software beizulegen. 
    DIE SOFTWARE WIRD OHNE JEDE AUSDRÜCKLICHE ODER IMPLIZIERTE GARANTIE BEREITGESTELLT,
    EINSCHLIEßLICH DER GARANTIE ZUR BENUTZUNG FÜR DEN VORGESEHENEN ODER EINEM
    BESTIMMTEN ZWECK SOWIE JEGLICHER RECHTSVERLETZUNG, JEDOCH NICHT DARAUF BESCHRÄNKT.
    IN KEINEM FALL SIND DIE AUTOREN ODER COPYRIGHTINHABER FÜR JEGLICHEN SCHADEN ODER
    SONSTIGE ANSPRÜCHE HAFTBAR ZU MACHEN, OB INFOLGE DER ERFÜLLUNG EINES VERTRAGES,
    EINES DELIKTES ODER ANDERS IM ZUSAMMENHANG MIT DER SOFTWARE ODER SONSTIGER
    VERWENDUNG DER SOFTWARE ENTSTANDEN. 
	----------------------------------------------------------------------------
	Versionshistory:
	16.01.2018	V1.06	released
	16.01.2018	V1.07	Unterscheidung Unilog2/Unisens
	18.01.2018	V1.08	Anzeige Nachkommastellen bei Stromanzeige 0-99.99A 2 Stellen
	
    
--]]
collectgarbage()
--------------------------------------------------------------------------------
local initAnimation = true
local model, owner = " ", " "
local trans, anSw, anGo
local playDone, sensorId, sensorPa, alarmValue
local sensid1, sensid2, sensid3, sensid4, ubec = 0, 0.0, 0, 0.0, 0.00
local sensid6, sensid8, sensid9 = 0, 0, 0
local capa1, remaining, minpwm, maxpwm = 0, 0, 0, 0
local minrpm, maxrpm, mincur, maxcur = 999, 0, 99.9, 0
local minvtg, maxvtg, mintmp, maxtmp = 99, 0, 99, 0
local fTime = {std=0, min=0, sec=0}
local time, lastTime, newTime = 0, 0, 0
local std, min, sec = 0, 0, 0
local minrxv, maxrxv, minrxa, maxrxa = 9.9, 0.0, 9.9, 0.0
local tSet, anTime, tInit1 = 0, 0, 0
local repeatlist = {}
local vFile1, vFile1changed, repeat1, vFile1Played

--------------------------------------------------------------------------------
-- Read translations
local function setLanguage()
    local lng=system.getLocale()
    local file = io.readall("Apps/Lang/DS14 JLog.jsn")
    local obj = json.decode(file)
    if(obj) then
        trans = obj[lng] or obj[obj.default]
    end
end
--------------------------------------------------------------------------------
-- Draw Battery and percentage display
local function drawBattery(Value, Alarm)
		-- Battery
			lcd.drawFilledRectangle(148, 48, 24, 7)	-- Top of Battery
			lcd.drawRectangle(134, 55, 52, 103)
		-- Level of Battery
			chgY = (158 - (Value * 1.02))
			chgH = (Value * 1.02)			
			lcd.drawFilledRectangle(135, chgY, 50, chgH)
		
		-- Percentage Display
		if( Value > Alarm ) then	
			lcd.drawRectangle(115, 2, 90, 43, 10)
			lcd.drawRectangle(114, 1, 92, 45, 11)
			lcd.drawText(160 - (lcd.getTextWidth(FONT_MAXI, string.format("%.0f%%",Value)) / 2),4, string.format("%.0f%%",Value),FONT_MAXI)
		else
			if( system.getTime() % 2 == 0 ) then -- blink every second
				lcd.drawRectangle(115, 2, 90, 43, 10)
				lcd.drawRectangle(114, 1, 92, 45, 11)
				lcd.drawText(160 - (lcd.getTextWidth(FONT_MAXI, string.format("%.0f%%",Value)) / 2),4, string.format("%.0f%%",Value),FONT_MAXI)
			end
		end
		
    collectgarbage()
end
--------------------------------------------------------------------------------
-- Draw left top box
local function drawLetopbox(Value, val2, val3)    -- Flugakku Spannung
		-- draw fixed Text
		lcd.drawText(57 - (lcd.getTextWidth(FONT_MINI,trans.mainbat) / 2),1,trans.mainbat,FONT_MINI)
		lcd.drawText(82, 20, "V", FONT_MINI)
		lcd.drawText(6, 32, "Min/Max:", FONT_MINI)
		
		-- draw Values
		if (Value >= 100) then
			lcd.drawText(80 - lcd.getTextWidth(FONT_BIG, string.format("%.1f",Value)),13, string.format("%.1f",Value), FONT_BIG)
		else
			lcd.drawText(80 - lcd.getTextWidth(FONT_BIG, string.format("%.2f",Value)),13, string.format("%.2f",Value), FONT_BIG)		
		end
		lcd.drawText(60, 32, string.format("%.1f - %.1f", val2, val3), FONT_MINI)
		
end
--------------------------------------------------------------------------------
-- Draw left middle box
local function drawLemidbox(Value, val2, val3)	-- Drehzahl
		-- draw fixed Text
		lcd.drawText(50 - (lcd.getTextWidth(FONT_MINI,trans.engspeed) / 2),50,trans.engspeed,FONT_MINI)
		lcd.drawText(82, 81, "U/min", FONT_MINI)
		lcd.drawText(6, 97, "Min/Max:", FONT_MINI)

		-- draw Values
		lcd.drawText(80 - lcd.getTextWidth(FONT_MAXI,string.format("%.0f",Value)),61,string.format("%.0f",Value),FONT_MAXI)
        lcd.drawText(60,97, string.format("%.0f - %.0f", val2, val3), FONT_MINI)
		
end
--------------------------------------------------------------------------------
-- Draw left bottom box
local function drawLebotbox(Value)	-- Rx Values
		-- draw fixed Text
		lcd.drawText(6, 148, "BEC-Spannung:", FONT_MINI)
		
		-- draw Modellname 
        lcd.drawText(3,120, model, FONT_BIG)
        

        -- Rx Voltage
    ubec = system.getTxTelemetry ()
        -- Rx Voltage reset to 0
    if  (Value <= 1 ) then  -- Value = Value from Ubat

    	lcd.drawText(94,148, "0.00 V", FONT_MINI)  

     else
        -- draw RxVoltage
        lcd.drawText(125 - lcd.getTextWidth(FONT_MINI, string.format("%.2f V",ubec.rx1Voltage)),148, string.format("%.2f V",ubec.rx1Voltage),FONT_MINI) 

   end
   
end
--------------------------------------------------------------------------------
-- Draw right top box
local function drawRitopbox(Value, val2, val3)	-- Flugzeit
		-- draw fixed Text
		lcd.drawText(265 - (lcd.getTextWidth(FONT_MINI, trans.ftime)/2), 1, trans.ftime, FONT_MINI)
		lcd.drawText(251 - (lcd.getTextWidth(FONT_MINI, trans.date)), 32, trans.date, FONT_MINI)

		
		-- draw Values
        lcd.drawText(255 - (lcd.getTextWidth(FONT_BIG, string.format("%0d:%02d:%02d", std, min, sec)) / 2), 13, string.format("%0d:%02d:%02d", std, min, sec), FONT_BIG)
		lcd.drawText(255, 32, string.format("%02d.%02d.%02d", val2.day, val2.mon, val2.year), FONT_MINI)
		
end
--------------------------------------------------------------------------------
-- Draw right middle box
local function drawRimidbox(Value, val2, val3)	-- Verbrauch Kapa
		-- draw fixed Text
		lcd.drawText(262 - (lcd.getTextWidth(FONT_MINI,trans.akku) / 2),50,trans.akku,FONT_MINI)
		lcd.drawText(283, 81, "mAh", FONT_MINI)
		lcd.drawText(204, 97, trans.capacity, FONT_MINI)

		-- draw Values
		lcd.drawText(278 - lcd.getTextWidth(FONT_MAXI, string.format("%.0f",Value)),61, string.format("%.0f",Value), FONT_MAXI)
        lcd.drawText(258,97, string.format("%s mAh", val2),FONT_MINI)
		
end
--------------------------------------------------------------------------------
-- Draw right bottom box
local function drawRibotbox(val1, val2, Value, val3)	-- Max Values

		-- draw fixed Text
		lcd.drawText(245, 113, "IBEC", FONT_MINI)
		lcd.drawText(245, 125, "IMot", FONT_MINI)
		lcd.drawText(245, 137, "PWM", FONT_MINI)
		lcd.drawText(245, 149, "ESC", FONT_MINI)
		
        lcd.drawText(307,113,"A",FONT_MINI)
        lcd.drawText(307,125,"A",FONT_MINI)
        lcd.drawText(305,137,"%",FONT_MINI)
        lcd.drawText(302,149,"°C",FONT_MINI)

		-- draw Max Values  
        lcd.drawText(300 - lcd.getTextWidth(FONT_MINI, string.format("%.1f",val1)),113, string.format("%.1f",val1),FONT_MINI)
        lcd.drawText(300 - lcd.getTextWidth(FONT_MINI, string.format("%.1f",val2)),125, string.format("%.1f",val2),FONT_MINI)
        lcd.drawText(300 - lcd.getTextWidth(FONT_MINI, string.format("%.1f",val2)),137, string.format("%.1f",Value),FONT_MINI)
        lcd.drawText(300 - lcd.getTextWidth(FONT_MINI, string.format("%.1f",val3)),149, string.format("%.1f",val3),FONT_MINI)

        -- draw "graph"
        lcd.drawLine(200, 140, 200, 120)
        lcd.drawLine(200, 140, 240, 140)
        lcd.drawLine(199, 121, 201, 121)
        lcd.drawLine(239, 139, 239, 141)
        lcd.drawLine(200 ,140, 217, 126)
        lcd.drawLine(200 ,139, 217, 125)
        lcd.drawLine(217, 126, 226, 138)
        lcd.drawLine(217 ,125, 226, 137)
        lcd.drawLine(226, 138, 240, 119)
        lcd.drawLine(226, 137, 240, 118)
        lcd.drawLine(223, 138, 223, 142)


        lcd.drawText(200,149,"TelMax:",FONT_MINI)
end

--------------------------------------------------------------------------------
-- Telemetriefenster Page1
local function Page1(width, height)

		-- animation demo at startup - fill tank up
		if( initAnimation ) then
			remaining = remaining - 3
			if remaining <= 0  then
				initAnimation = false
			end
		end	

		drawBattery(remaining, alarmValue)
		drawLetopbox(sensid1, minvtg, maxvtg)	-- Variablen sind aktueller Spannung, Minimalspannung, Maximalspannung im Stringformat
		drawLemidbox(sensid3, minrpm, maxrpm)	-- Variablen sind aktuelle Drehzahl, Minimaldrehzahl, Maximaldrehzahl
		drawLebotbox(sensid1)	-- Variablen sind Empfängerspannung
		drawRitopbox("fTime", today, 0)	-- Variablen sind Flugzeit, Datum, Null
		drawRimidbox(sensid4, capa1, 0)	-- Variablen sind Verbrauchte Kapazität, Akkukapazität, Null
		drawRibotbox(maxrxa, maxcur, maxpwm, maxtmp) -- Variablen sind BEC Strom, Motorstrom,PWM, FET Temperaur, jeweils Maxwerte
		
	-- draw horizontal lines
		lcd.drawFilledRectangle(4, 47, 104, 2)     --lo
		lcd.drawFilledRectangle(4, 111, 116, 2)    --lu
		lcd.drawFilledRectangle(212, 47, 104, 2)   --ro
		lcd.drawFilledRectangle(200, 111, 116, 2)  --ru
		

end
--------------------------------------------------------------------------------
-- Take care of user's settings-changes
local function sensorChanged(value)
	sensorId  = sensorsAvailable[value].id
	system.pSave("sensorId", sensorId)
end

local function capa1Changed(value)
	capa1 = value
	system.pSave("capa1", capa1)
end

local function alarmValueChanged(value)
    alarmValue = value
    system.pSave("alarmValue", alarmValue)
end

local function alarmVoiceChanged(value)
    alarmVoice = value
    system.pSave("alarmVoice", alarmVoice)
end

local function timeSwChanged(value)
    timeSw = value
    system.pSave("timeSw", timeSw)
end

local function resSwChanged(value)
    resSw = value
    system.pSave("resSw", resSw)
end

local function anSwChanged(value)
    anSw = value
    system.pSave("anSw", anSw)
end

local function time1Changed(value)
	time1=value
	system.pSave("time1",value)
end

local function alarm1Changed(value)
	alarm1=value
	system.pSave("alarm1",value)
end

local function vFile1Changed(value)
	vFile1=value
	system.pSave("vFile1",value)
end

local function repeat1Changed(value)
	repeat1=value
	system.pSave("repeat1",value)
end
--------------------------------------------------------------------------------
local function setupForm(formID)
    -- List sensors only if menu is active to preserve memory at runtime 
    -- (measured up to 25% save if menu is not opened)
    sensorsAvailable = {}
  local available = system.getSensors();
  local list={}
  local curIndex=-1
  local descr = ""
  for index,sensor in ipairs(available) do 
    if(sensor.param == 0) then
      list[#list+1] = sensor.label
      sensorsAvailable[#sensorsAvailable+1] = sensor
      if(sensor.id==sensorId ) then
        curIndex=#sensorsAvailable
      end 
    end
    end 
    
    local form, addRow, addLabel = form, form.addRow ,form.addLabel
    local addIntbox, addSelectbox = form.addIntbox, form.addSelectbox
    local addInputbox, addCheckbox = form.addInputbox, form.addCheckbox
    local addAudioFilebox, setButton = form.addAudioFilebox, form.setButton
	local setTitle, addSpacer = form.setTitle, form.addSpacer
    
	setTitle(trans.title)
				
	addSpacer(318,7)		

    addRow(1)
    addLabel({label=trans.label1,font=FONT_BOLD})
    
    addRow(2)
    addLabel({label = trans.selectsens, width=200})
    addSelectbox(list, curIndex, true, sensorChanged)
    
	addRow(2)
	addLabel({label=trans.anSw})
	addInputbox(anSw,true,anSwChanged)
	
	addSpacer(318,7)

    addRow(1)
    addLabel({label=trans.label3,font=FONT_BOLD})

	addRow(2)
	addLabel({label=trans.selTime})
	addIntbox(time1,0,60,0,0,1,time1Changed)
	
	addRow(2)
	addLabel({label=trans.alarmThr})
	addIntbox(string.format("%.1f",alarm1),0,1000,0,1,1,alarm1Changed)
	
	addRow(2)
	addLabel({label=trans.selAudio})
	addAudioFilebox(vFile1,vFile1Changed)
	
	addRow(2)
	addLabel({label=trans.rpt,width=200})
	addSelectbox(repeatlist,repeat1,false,repeat1Changed)
	
	addSpacer(318,7)

    addRow(1)
    addLabel({label=trans.label2,font=FONT_BOLD})
    
    addRow(2)
    addLabel({label=trans.capa1, width=230})
    addIntbox(capa1, 0, 32767, 0, 0, 10, capa1Changed)
    
    addRow(2)
    addLabel({label=trans.alarmValue, width=230})
    addIntbox(alarmValue, 0, 100, 0, 0, 1, alarmValueChanged)
    
    addRow(2)
    addLabel({label=trans.voiceFile})
    addAudioFilebox(alarmVoice, alarmVoiceChanged)
	
	addSpacer(318,7)		

	addRow(2)
	addLabel({label=trans.timeSw})
	addInputbox(timeSw,true,timeSwChanged)
	
	addRow(2)
	addLabel({label=trans.resSw})
	addInputbox(resSw,true,resSwChanged)
	
	addSpacer(318,7)		

	addRow(1)
	addLabel({label="Powered by A. Fromm "..Version.." ", font=FONT_MINI, alignRight=true})
    
    collectgarbage()
end
--------------------------------------------------------------------------------
-- Fligt time
local function FlightTime()
	newTime = system.getTimeCounter()
	ltimeSw = system.getInputsVal(timeSw)
	resetSw = system.getInputsVal(resSw)

	if (ltimeSw ~= 1 and resetSw == 1) then time = 0 end
	
	if (ltimeSw == 1) then		
		if newTime > (lastTime + 1000) then  -- nach einer sec.
			lastTime = newTime
			time = time + 1
		end
	end	
	std = math.floor(time / 3600)
	min = math.floor(time / 60) - std * 60
	sec = time - min * 60
end
---------------------------------------------------------------------------------
local function loop()

		local P8 = ((system.getInputs("P8") + 1) / 2) * 100	--Nur zum Testen!!!
		local anGo = system.getInputsVal(anSw)
		local tTime = system.getTime()
		----------------------------------------------------------------
		-- Aufruf Flugzeit
		FlightTime()

		-- Read Sensor ID 1 Spannung 
		sensor = system.getSensorByID(sensorId, 1)
		if(sensor and sensor.valid) then sensid1 = sensor.value
		-- calculate Min/Max Sensor 1
			if sensid1 < minvtg then minvtg = sensid1 end
			if sensid1 > maxvtg then maxvtg = sensid1 end
			---------------------------------------------
			if sensid1 < 0.2 then tInit1 = 0 end
			
			if(tInit1 and tInit1 > 1) then
			else
				tInit1 = system.getTime()
				tStart1 = (tInit1 + 3)
				tStop1 = (tStart1 + 60)
				tPlay1 = (tInit1 + time1)
			end
			if (tStart1 <= tTime and tStop1 >= tTime) then
				if(sensid1 <= (alarm1/10)) then
					if(tTime >= tPlay1 and vFile1played ~= 1) then
						if (repeat1 == 2) then
							system.messageBox(trans.sysWarn,5)
							system.playFile(vFile1,AUDIO_AUDIO_QUEUE)
							system.playFile(vFile1,AUDIO_AUDIO_QUEUE)
							system.playFile(vFile1,AUDIO_AUDIO_QUEUE)
							vFile1played = 1
						else
							system.messageBox(trans.sysWarn,5)
							system.playFile(vFile1,AUDIO_AUDIO_QUEUE)
							vFile1played = 1
						end
					end
				
				else
					vFile1played = 0
				end
			else
				vFile1played = 0
			end
		---------------------------------------------
		else
			sensid1 = 0
			tInit1 = 0
		end

		-- Read Sensor ID 2 Strom 
		sensor = system.getSensorByID(sensorId, 2)
		if(sensor and sensor.valid) then sensid2 = sensor.value
			-- calculate Min/Max Sensor 2
			if sensid2 < mincur then mincur = sensid2 end
			if sensid2 > maxcur then maxcur = sensid2 end
		else
			sensid2 = 0
		end

        -- Read Sensor ID 3 Drehzahl
		sensor = system.getSensorByID(sensorId, 3)
		if(sensor and sensor.valid) then sensid3 = sensor.value
			-- calculate Min/Max Sensor 3
			if sensid3 < minrpm then minrpm = sensid3 end
			if sensid3 > maxrpm then maxrpm = sensid3 end
		else
			sensid3 = 0
		end

		-- Read Sensor ID 4 verbrauchte Kapazität
		sensor = system.getSensorByID(sensorId, 4)
		if(sensor and sensor.valid and (sensid1 > 1.0)) then sensid4 = sensor.value
			remaining = math.floor(((capa1 - sensor.value) * 100) / capa1)		
			

			-- If we have consumed more than allowed sound alarmValue
			if(not playDone and remaining <= alarmValue and alarmVoice ~= "..." and sensor and sensor.valid) then
				system.playFile(alarmVoice,AUDIO_QUEUE)
				system.playNumber(remaining, 0, "%", "Capacity")
				playDone = true   
			end
			-- If we are above consumption alarm-level enable alarm
			if(remaining > alarmValue) then playDone = false
			end
			if(anGo == 1 and anTime < tTime) then
			system.playNumber(remaining, 0, "%", "Capacity")
			anTime = tTime + 3
			end

			-- Set max/min percentage to 99/0 for drawing
			if( remaining > 100 ) then remaining = 100 end
			if( remaining < 0 ) then remaining = 0 end

		else
			if (initAnimation == false) then
				remaining = 0
			end
			sensid4 = 0
		end	

        -- Read Sensor ID 4 Kapa 
		sensor = system.getSensorByID(sensorId, 4)
		if(sensor and sensor.valid) then sensid4 = sensor.value end

        -- Read Sensor ID 6 IBEC 
		sensor = system.getSensorByID(sensorId, 6)
		if(sensor and sensor.valid) then sensid6 = sensor.value 
		    if sensid6 < minrxa then minrxa = sensid6 end
			if sensid6 > maxrxa then maxrxa = sensid6 end
		else
			sensid6 = 0
		end

		-- Read Sensor ID 8 PWM
		sensor = system.getSensorByID(sensorId, 8)
		if(sensor and sensor.valid) then sensid8 = sensor.value
            if sensid8 < minpwm then minpwm = sensid8 end
			if sensid8 > maxpwm then maxpwm = sensid8 end
		else
			sensid8 = 0
        end

		-- Read Sensor ID 9 FET Temperatur
		sensor = system.getSensorByID(sensorId, 9)
		if(sensor and sensor.valid) then sensid9 = sensor.value 
            if sensid9 < mintmp then mintmp = sensid9 end
			if sensid9 > maxtmp then maxtmp = sensid9 end
		else
			sensid9 = 0
		end
		
   collectgarbage()
   
end
--------------------------------------------------------------------------------
local function init(code1)
    local pLoad, registerForm, registerTelemetry = system.pLoad, system.registerForm, system.registerTelemetry
	remaining = 100
	model = system.getProperty("Model")
	owner = system.getUserName()
	today = system.getDateTime()
	sensorId = pLoad("sensorId", 0)
	capa1 = pLoad("capa1",0)
    alarmValue = pLoad("alarmValue", 0)
    alarmVoice = pLoad("alarmVoice", "...")
	timeSw = pLoad("timeSw")
	resSw = pLoad("resSw")
	anSw = pLoad("anSw")
	time1 = pLoad("time1",0)
	alarm1 = pLoad("alarm1",0)
	vFile1 = pLoad("vFile1","...")
	repeat1 = pLoad("repeat1",1)
    registerForm(1, MENU_APPS, trans.appName1, setupForm)
    registerTelemetry(1, trans.appName1, 4, Page1) --registers a full size Window
--    registerTelemetry(2, xstrans.appName2.." "..model, 4, page2) --registers a full size Window
	table.insert(repeatlist,trans.neg)
	table.insert(repeatlist,trans.pos)
    collectgarbage()
end
--------------------------------------------------------------------------------
Version = "1.08"
setLanguage()
collectgarbage()
return {init=init, loop=loop, author="A. Fromm", version=Version, name=trans.appName1}